// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from dbw_fca_msgs:msg/Misc1Report.idl
// generated code does not contain a copyright notice
#include "dbw_fca_msgs/msg/detail/misc1_report__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `turn_signal`
#include "dbw_fca_msgs/msg/detail/turn_signal__functions.h"
// Member `high_beam`
#include "dbw_fca_msgs/msg/detail/high_beam__functions.h"
// Member `wiper`
#include "dbw_fca_msgs/msg/detail/wiper__functions.h"

bool
dbw_fca_msgs__msg__Misc1Report__init(dbw_fca_msgs__msg__Misc1Report * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    dbw_fca_msgs__msg__Misc1Report__fini(msg);
    return false;
  }
  // turn_signal
  if (!dbw_fca_msgs__msg__TurnSignal__init(&msg->turn_signal)) {
    dbw_fca_msgs__msg__Misc1Report__fini(msg);
    return false;
  }
  // high_beam
  if (!dbw_fca_msgs__msg__HighBeam__init(&msg->high_beam)) {
    dbw_fca_msgs__msg__Misc1Report__fini(msg);
    return false;
  }
  // wiper
  if (!dbw_fca_msgs__msg__Wiper__init(&msg->wiper)) {
    dbw_fca_msgs__msg__Misc1Report__fini(msg);
    return false;
  }
  // btn_cc_on_off
  // btn_cc_res
  // btn_cc_cncl
  // btn_cc_set_inc
  // btn_cc_set_dec
  // btn_cc_gap_inc
  // btn_cc_gap_dec
  // btn_cc_mode
  // btn_ld_ok
  // btn_ld_up
  // btn_ld_down
  // btn_ld_left
  // btn_ld_right
  // fault_bus
  // door_rear_left
  // door_rear_right
  // door_trunk
  return true;
}

void
dbw_fca_msgs__msg__Misc1Report__fini(dbw_fca_msgs__msg__Misc1Report * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // turn_signal
  dbw_fca_msgs__msg__TurnSignal__fini(&msg->turn_signal);
  // high_beam
  dbw_fca_msgs__msg__HighBeam__fini(&msg->high_beam);
  // wiper
  dbw_fca_msgs__msg__Wiper__fini(&msg->wiper);
  // btn_cc_on_off
  // btn_cc_res
  // btn_cc_cncl
  // btn_cc_set_inc
  // btn_cc_set_dec
  // btn_cc_gap_inc
  // btn_cc_gap_dec
  // btn_cc_mode
  // btn_ld_ok
  // btn_ld_up
  // btn_ld_down
  // btn_ld_left
  // btn_ld_right
  // fault_bus
  // door_rear_left
  // door_rear_right
  // door_trunk
}

dbw_fca_msgs__msg__Misc1Report *
dbw_fca_msgs__msg__Misc1Report__create()
{
  dbw_fca_msgs__msg__Misc1Report * msg = (dbw_fca_msgs__msg__Misc1Report *)malloc(sizeof(dbw_fca_msgs__msg__Misc1Report));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(dbw_fca_msgs__msg__Misc1Report));
  bool success = dbw_fca_msgs__msg__Misc1Report__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
dbw_fca_msgs__msg__Misc1Report__destroy(dbw_fca_msgs__msg__Misc1Report * msg)
{
  if (msg) {
    dbw_fca_msgs__msg__Misc1Report__fini(msg);
  }
  free(msg);
}


bool
dbw_fca_msgs__msg__Misc1Report__Sequence__init(dbw_fca_msgs__msg__Misc1Report__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  dbw_fca_msgs__msg__Misc1Report * data = NULL;
  if (size) {
    data = (dbw_fca_msgs__msg__Misc1Report *)calloc(size, sizeof(dbw_fca_msgs__msg__Misc1Report));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = dbw_fca_msgs__msg__Misc1Report__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        dbw_fca_msgs__msg__Misc1Report__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
dbw_fca_msgs__msg__Misc1Report__Sequence__fini(dbw_fca_msgs__msg__Misc1Report__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      dbw_fca_msgs__msg__Misc1Report__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

dbw_fca_msgs__msg__Misc1Report__Sequence *
dbw_fca_msgs__msg__Misc1Report__Sequence__create(size_t size)
{
  dbw_fca_msgs__msg__Misc1Report__Sequence * array = (dbw_fca_msgs__msg__Misc1Report__Sequence *)malloc(sizeof(dbw_fca_msgs__msg__Misc1Report__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = dbw_fca_msgs__msg__Misc1Report__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
dbw_fca_msgs__msg__Misc1Report__Sequence__destroy(dbw_fca_msgs__msg__Misc1Report__Sequence * array)
{
  if (array) {
    dbw_fca_msgs__msg__Misc1Report__Sequence__fini(array);
  }
  free(array);
}
