// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from dbw_fca_msgs:msg/ThrottleInfoReport.idl
// generated code does not contain a copyright notice
#include "dbw_fca_msgs/msg/detail/throttle_info_report__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `gear_num`
#include "dbw_fca_msgs/msg/detail/gear_num__functions.h"
// Member `ignition`
#include "dbw_fca_msgs/msg/detail/ignition__functions.h"

bool
dbw_fca_msgs__msg__ThrottleInfoReport__init(dbw_fca_msgs__msg__ThrottleInfoReport * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    dbw_fca_msgs__msg__ThrottleInfoReport__fini(msg);
    return false;
  }
  // throttle_pc
  // axle_torque
  // gear_num
  if (!dbw_fca_msgs__msg__GearNum__init(&msg->gear_num)) {
    dbw_fca_msgs__msg__ThrottleInfoReport__fini(msg);
    return false;
  }
  // ignition
  if (!dbw_fca_msgs__msg__Ignition__init(&msg->ignition)) {
    dbw_fca_msgs__msg__ThrottleInfoReport__fini(msg);
    return false;
  }
  return true;
}

void
dbw_fca_msgs__msg__ThrottleInfoReport__fini(dbw_fca_msgs__msg__ThrottleInfoReport * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // throttle_pc
  // axle_torque
  // gear_num
  dbw_fca_msgs__msg__GearNum__fini(&msg->gear_num);
  // ignition
  dbw_fca_msgs__msg__Ignition__fini(&msg->ignition);
}

dbw_fca_msgs__msg__ThrottleInfoReport *
dbw_fca_msgs__msg__ThrottleInfoReport__create()
{
  dbw_fca_msgs__msg__ThrottleInfoReport * msg = (dbw_fca_msgs__msg__ThrottleInfoReport *)malloc(sizeof(dbw_fca_msgs__msg__ThrottleInfoReport));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(dbw_fca_msgs__msg__ThrottleInfoReport));
  bool success = dbw_fca_msgs__msg__ThrottleInfoReport__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
dbw_fca_msgs__msg__ThrottleInfoReport__destroy(dbw_fca_msgs__msg__ThrottleInfoReport * msg)
{
  if (msg) {
    dbw_fca_msgs__msg__ThrottleInfoReport__fini(msg);
  }
  free(msg);
}


bool
dbw_fca_msgs__msg__ThrottleInfoReport__Sequence__init(dbw_fca_msgs__msg__ThrottleInfoReport__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  dbw_fca_msgs__msg__ThrottleInfoReport * data = NULL;
  if (size) {
    data = (dbw_fca_msgs__msg__ThrottleInfoReport *)calloc(size, sizeof(dbw_fca_msgs__msg__ThrottleInfoReport));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = dbw_fca_msgs__msg__ThrottleInfoReport__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        dbw_fca_msgs__msg__ThrottleInfoReport__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
dbw_fca_msgs__msg__ThrottleInfoReport__Sequence__fini(dbw_fca_msgs__msg__ThrottleInfoReport__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      dbw_fca_msgs__msg__ThrottleInfoReport__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

dbw_fca_msgs__msg__ThrottleInfoReport__Sequence *
dbw_fca_msgs__msg__ThrottleInfoReport__Sequence__create(size_t size)
{
  dbw_fca_msgs__msg__ThrottleInfoReport__Sequence * array = (dbw_fca_msgs__msg__ThrottleInfoReport__Sequence *)malloc(sizeof(dbw_fca_msgs__msg__ThrottleInfoReport__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = dbw_fca_msgs__msg__ThrottleInfoReport__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
dbw_fca_msgs__msg__ThrottleInfoReport__Sequence__destroy(dbw_fca_msgs__msg__ThrottleInfoReport__Sequence * array)
{
  if (array) {
    dbw_fca_msgs__msg__ThrottleInfoReport__Sequence__fini(array);
  }
  free(array);
}
