// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from dbw_fca_msgs:msg/GearReport.idl
// generated code does not contain a copyright notice
#include "dbw_fca_msgs/msg/detail/gear_report__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `state`
// Member `cmd`
#include "dbw_fca_msgs/msg/detail/gear__functions.h"
// Member `reject`
#include "dbw_fca_msgs/msg/detail/gear_reject__functions.h"

bool
dbw_fca_msgs__msg__GearReport__init(dbw_fca_msgs__msg__GearReport * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    dbw_fca_msgs__msg__GearReport__fini(msg);
    return false;
  }
  // state
  if (!dbw_fca_msgs__msg__Gear__init(&msg->state)) {
    dbw_fca_msgs__msg__GearReport__fini(msg);
    return false;
  }
  // cmd
  if (!dbw_fca_msgs__msg__Gear__init(&msg->cmd)) {
    dbw_fca_msgs__msg__GearReport__fini(msg);
    return false;
  }
  // reject
  if (!dbw_fca_msgs__msg__GearReject__init(&msg->reject)) {
    dbw_fca_msgs__msg__GearReport__fini(msg);
    return false;
  }
  // override
  // fault_bus
  return true;
}

void
dbw_fca_msgs__msg__GearReport__fini(dbw_fca_msgs__msg__GearReport * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // state
  dbw_fca_msgs__msg__Gear__fini(&msg->state);
  // cmd
  dbw_fca_msgs__msg__Gear__fini(&msg->cmd);
  // reject
  dbw_fca_msgs__msg__GearReject__fini(&msg->reject);
  // override
  // fault_bus
}

dbw_fca_msgs__msg__GearReport *
dbw_fca_msgs__msg__GearReport__create()
{
  dbw_fca_msgs__msg__GearReport * msg = (dbw_fca_msgs__msg__GearReport *)malloc(sizeof(dbw_fca_msgs__msg__GearReport));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(dbw_fca_msgs__msg__GearReport));
  bool success = dbw_fca_msgs__msg__GearReport__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
dbw_fca_msgs__msg__GearReport__destroy(dbw_fca_msgs__msg__GearReport * msg)
{
  if (msg) {
    dbw_fca_msgs__msg__GearReport__fini(msg);
  }
  free(msg);
}


bool
dbw_fca_msgs__msg__GearReport__Sequence__init(dbw_fca_msgs__msg__GearReport__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  dbw_fca_msgs__msg__GearReport * data = NULL;
  if (size) {
    data = (dbw_fca_msgs__msg__GearReport *)calloc(size, sizeof(dbw_fca_msgs__msg__GearReport));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = dbw_fca_msgs__msg__GearReport__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        dbw_fca_msgs__msg__GearReport__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
dbw_fca_msgs__msg__GearReport__Sequence__fini(dbw_fca_msgs__msg__GearReport__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      dbw_fca_msgs__msg__GearReport__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

dbw_fca_msgs__msg__GearReport__Sequence *
dbw_fca_msgs__msg__GearReport__Sequence__create(size_t size)
{
  dbw_fca_msgs__msg__GearReport__Sequence * array = (dbw_fca_msgs__msg__GearReport__Sequence *)malloc(sizeof(dbw_fca_msgs__msg__GearReport__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = dbw_fca_msgs__msg__GearReport__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
dbw_fca_msgs__msg__GearReport__Sequence__destroy(dbw_fca_msgs__msg__GearReport__Sequence * array)
{
  if (array) {
    dbw_fca_msgs__msg__GearReport__Sequence__fini(array);
  }
  free(array);
}
