// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from dbw_fca_msgs:msg/HvacSeat.idl
// generated code does not contain a copyright notice

#ifndef DBW_FCA_MSGS__MSG__DETAIL__HVAC_SEAT__FUNCTIONS_H_
#define DBW_FCA_MSGS__MSG__DETAIL__HVAC_SEAT__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "dbw_fca_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "dbw_fca_msgs/msg/detail/hvac_seat__struct.h"

/// Initialize msg/HvacSeat message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * dbw_fca_msgs__msg__HvacSeat
 * )) before or use
 * dbw_fca_msgs__msg__HvacSeat__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_dbw_fca_msgs
bool
dbw_fca_msgs__msg__HvacSeat__init(dbw_fca_msgs__msg__HvacSeat * msg);

/// Finalize msg/HvacSeat message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_dbw_fca_msgs
void
dbw_fca_msgs__msg__HvacSeat__fini(dbw_fca_msgs__msg__HvacSeat * msg);

/// Create msg/HvacSeat message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * dbw_fca_msgs__msg__HvacSeat__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_dbw_fca_msgs
dbw_fca_msgs__msg__HvacSeat *
dbw_fca_msgs__msg__HvacSeat__create();

/// Destroy msg/HvacSeat message.
/**
 * It calls
 * dbw_fca_msgs__msg__HvacSeat__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_dbw_fca_msgs
void
dbw_fca_msgs__msg__HvacSeat__destroy(dbw_fca_msgs__msg__HvacSeat * msg);


/// Initialize array of msg/HvacSeat messages.
/**
 * It allocates the memory for the number of elements and calls
 * dbw_fca_msgs__msg__HvacSeat__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_dbw_fca_msgs
bool
dbw_fca_msgs__msg__HvacSeat__Sequence__init(dbw_fca_msgs__msg__HvacSeat__Sequence * array, size_t size);

/// Finalize array of msg/HvacSeat messages.
/**
 * It calls
 * dbw_fca_msgs__msg__HvacSeat__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_dbw_fca_msgs
void
dbw_fca_msgs__msg__HvacSeat__Sequence__fini(dbw_fca_msgs__msg__HvacSeat__Sequence * array);

/// Create array of msg/HvacSeat messages.
/**
 * It allocates the memory for the array and calls
 * dbw_fca_msgs__msg__HvacSeat__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_dbw_fca_msgs
dbw_fca_msgs__msg__HvacSeat__Sequence *
dbw_fca_msgs__msg__HvacSeat__Sequence__create(size_t size);

/// Destroy array of msg/HvacSeat messages.
/**
 * It calls
 * dbw_fca_msgs__msg__HvacSeat__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_dbw_fca_msgs
void
dbw_fca_msgs__msg__HvacSeat__Sequence__destroy(dbw_fca_msgs__msg__HvacSeat__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // DBW_FCA_MSGS__MSG__DETAIL__HVAC_SEAT__FUNCTIONS_H_
