// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from dbw_fca_msgs:msg/Misc2Report.idl
// generated code does not contain a copyright notice
#include "dbw_fca_msgs/msg/detail/misc2_report__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `ft_drv_temp`
// Member `ft_psg_temp`
#include "dbw_fca_msgs/msg/detail/front_temp__functions.h"
// Member `ft_fan_speed`
#include "dbw_fca_msgs/msg/detail/front_fan_speed__functions.h"
// Member `vent_mode`
#include "dbw_fca_msgs/msg/detail/vent_mode__functions.h"
// Member `fl_heated_seat`
// Member `fl_vented_seat`
// Member `fr_heated_seat`
// Member `fr_vented_seat`
#include "dbw_fca_msgs/msg/detail/hvac_seat__functions.h"

bool
dbw_fca_msgs__msg__Misc2Report__init(dbw_fca_msgs__msg__Misc2Report * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    dbw_fca_msgs__msg__Misc2Report__fini(msg);
    return false;
  }
  // ft_drv_temp
  if (!dbw_fca_msgs__msg__FrontTemp__init(&msg->ft_drv_temp)) {
    dbw_fca_msgs__msg__Misc2Report__fini(msg);
    return false;
  }
  // ft_psg_temp
  if (!dbw_fca_msgs__msg__FrontTemp__init(&msg->ft_psg_temp)) {
    dbw_fca_msgs__msg__Misc2Report__fini(msg);
    return false;
  }
  // ft_fan_speed
  if (!dbw_fca_msgs__msg__FrontFanSpeed__init(&msg->ft_fan_speed)) {
    dbw_fca_msgs__msg__Misc2Report__fini(msg);
    return false;
  }
  // max_ac
  // ac
  // ft_hvac
  // auto_md
  // recirc
  // sync
  // r_defr
  // f_defr
  // vent_mode
  if (!dbw_fca_msgs__msg__VentMode__init(&msg->vent_mode)) {
    dbw_fca_msgs__msg__Misc2Report__fini(msg);
    return false;
  }
  // heated_steering_wheel
  // fl_heated_seat
  if (!dbw_fca_msgs__msg__HvacSeat__init(&msg->fl_heated_seat)) {
    dbw_fca_msgs__msg__Misc2Report__fini(msg);
    return false;
  }
  // fl_vented_seat
  if (!dbw_fca_msgs__msg__HvacSeat__init(&msg->fl_vented_seat)) {
    dbw_fca_msgs__msg__Misc2Report__fini(msg);
    return false;
  }
  // fr_heated_seat
  if (!dbw_fca_msgs__msg__HvacSeat__init(&msg->fr_heated_seat)) {
    dbw_fca_msgs__msg__Misc2Report__fini(msg);
    return false;
  }
  // fr_vented_seat
  if (!dbw_fca_msgs__msg__HvacSeat__init(&msg->fr_vented_seat)) {
    dbw_fca_msgs__msg__Misc2Report__fini(msg);
    return false;
  }
  return true;
}

void
dbw_fca_msgs__msg__Misc2Report__fini(dbw_fca_msgs__msg__Misc2Report * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // ft_drv_temp
  dbw_fca_msgs__msg__FrontTemp__fini(&msg->ft_drv_temp);
  // ft_psg_temp
  dbw_fca_msgs__msg__FrontTemp__fini(&msg->ft_psg_temp);
  // ft_fan_speed
  dbw_fca_msgs__msg__FrontFanSpeed__fini(&msg->ft_fan_speed);
  // max_ac
  // ac
  // ft_hvac
  // auto_md
  // recirc
  // sync
  // r_defr
  // f_defr
  // vent_mode
  dbw_fca_msgs__msg__VentMode__fini(&msg->vent_mode);
  // heated_steering_wheel
  // fl_heated_seat
  dbw_fca_msgs__msg__HvacSeat__fini(&msg->fl_heated_seat);
  // fl_vented_seat
  dbw_fca_msgs__msg__HvacSeat__fini(&msg->fl_vented_seat);
  // fr_heated_seat
  dbw_fca_msgs__msg__HvacSeat__fini(&msg->fr_heated_seat);
  // fr_vented_seat
  dbw_fca_msgs__msg__HvacSeat__fini(&msg->fr_vented_seat);
}

dbw_fca_msgs__msg__Misc2Report *
dbw_fca_msgs__msg__Misc2Report__create()
{
  dbw_fca_msgs__msg__Misc2Report * msg = (dbw_fca_msgs__msg__Misc2Report *)malloc(sizeof(dbw_fca_msgs__msg__Misc2Report));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(dbw_fca_msgs__msg__Misc2Report));
  bool success = dbw_fca_msgs__msg__Misc2Report__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
dbw_fca_msgs__msg__Misc2Report__destroy(dbw_fca_msgs__msg__Misc2Report * msg)
{
  if (msg) {
    dbw_fca_msgs__msg__Misc2Report__fini(msg);
  }
  free(msg);
}


bool
dbw_fca_msgs__msg__Misc2Report__Sequence__init(dbw_fca_msgs__msg__Misc2Report__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  dbw_fca_msgs__msg__Misc2Report * data = NULL;
  if (size) {
    data = (dbw_fca_msgs__msg__Misc2Report *)calloc(size, sizeof(dbw_fca_msgs__msg__Misc2Report));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = dbw_fca_msgs__msg__Misc2Report__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        dbw_fca_msgs__msg__Misc2Report__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
dbw_fca_msgs__msg__Misc2Report__Sequence__fini(dbw_fca_msgs__msg__Misc2Report__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      dbw_fca_msgs__msg__Misc2Report__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

dbw_fca_msgs__msg__Misc2Report__Sequence *
dbw_fca_msgs__msg__Misc2Report__Sequence__create(size_t size)
{
  dbw_fca_msgs__msg__Misc2Report__Sequence * array = (dbw_fca_msgs__msg__Misc2Report__Sequence *)malloc(sizeof(dbw_fca_msgs__msg__Misc2Report__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = dbw_fca_msgs__msg__Misc2Report__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
dbw_fca_msgs__msg__Misc2Report__Sequence__destroy(dbw_fca_msgs__msg__Misc2Report__Sequence * array)
{
  if (array) {
    dbw_fca_msgs__msg__Misc2Report__Sequence__fini(array);
  }
  free(array);
}
